﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net;
using uPLibrary.Networking.M2Mqtt.Messages;
using System.Security.Cryptography;
using System.Timers;

namespace uPLibrary.Networking.M2Mqtt
{
    public partial class Form1 : Form
    {

        Label[] diNameLabels = new Label[16];
        Label[] diValueLabels = new Label[16];
        Label[] aiNameLabels = new Label[8];
        Label[] aiValueLabels = new Label[8];
        Label[] tiNameLabels = new Label[8];
        Label[] tiValueLabels = new Label[8];
        System.Timers.Timer aTimer = new System.Timers.Timer();
        static string result = "";
        int counter = 0;
        string writeTopic;
        string readTopic;
        string notificationTopic;

        public Form1()
        {
            InitializeComponent();
            diNameLabels[0] = diName1;
            diNameLabels[1] = diName2;
            diNameLabels[2] = diName3;
            diNameLabels[3] = diName4;
            diNameLabels[4] = diName5;
            diNameLabels[5] = diName6;
            diNameLabels[6] = diName7;
            diNameLabels[7] = diName8;
            diNameLabels[8] = diName9;
            diNameLabels[9] = diName10;
            diNameLabels[10] = diName11;
            diNameLabels[11] = diName12;
            diNameLabels[12] = diName13;
            diNameLabels[13] = diName14;
            diNameLabels[14] = diName15;
            diNameLabels[15] = diName16;

            diValueLabels[0] = diValue1;
            diValueLabels[1] = diValue2;
            diValueLabels[2] = diValue3;
            diValueLabels[3] = diValue4;
            diValueLabels[4] = diValue5;
            diValueLabels[5] = diValue6;
            diValueLabels[6] = diValue7;
            diValueLabels[7] = diValue8;
            diValueLabels[8] = diValue9;
            diValueLabels[9] = diValue10;
            diValueLabels[10] = diValue11;
            diValueLabels[11] = diValue12;
            diValueLabels[12] = diValue13;
            diValueLabels[13] = diValue14;
            diValueLabels[14] = diValue15;
            diValueLabels[15] = diValue16;

            aiNameLabels[0] = aiName1;
            aiNameLabels[1] = aiName2;
            aiNameLabels[2] = aiName3;
            aiNameLabels[3] = aiName4;
            aiNameLabels[4] = aiName5;
            aiNameLabels[5] = aiName6;
            aiNameLabels[6] = aiName7;
            aiNameLabels[7] = aiName8;

            aiValueLabels[0] = aiValue1;
            aiValueLabels[1] = aiValue2;
            aiValueLabels[2] = aiValue3;
            aiValueLabels[3] = aiValue4;
            aiValueLabels[4] = aiValue5;
            aiValueLabels[5] = aiValue6;
            aiValueLabels[6] = aiValue7;
            aiValueLabels[7] = aiValue8;

            tiNameLabels[0] = tiName1;
            tiNameLabels[1] = tiName2;
            tiNameLabels[2] = tiName3;
            tiNameLabels[3] = tiName4;
            tiNameLabels[4] = tiName5;
            tiNameLabels[5] = tiName6;
            tiNameLabels[6] = tiName7;
            tiNameLabels[7] = tiName8;

            tiValueLabels[0] = tiValue1;
            tiValueLabels[1] = tiValue2;
            tiValueLabels[2] = tiValue3;
            tiValueLabels[3] = tiValue4;
            tiValueLabels[4] = tiValue5;
            tiValueLabels[5] = tiValue6;
            tiValueLabels[6] = tiValue7;
            tiValueLabels[7] = tiValue8;

            aTimer.Elapsed += new ElapsedEventHandler(OnTimedEvent);
        }

        // Specify what you want to happen when the Elapsed event is raised.
        public void OnTimedEvent(object source, ElapsedEventArgs e)
        {
            counter++;
            //if (result == "")
                SetText("Polling " + counter + " times", statusLabel);
            //else
              //  SetText("", statusLabel);
            if (result == "" && counter == 3)
            {
                SetText("Tried " + counter + " times but no result. Check MQTT Settings and/or Internet Connection.", statusLabel);
                endClient();
                aTimer.Enabled = false;
                SetButton(true, startButton);
                SetButton(false, stopButton);
            }
            //SetText("Times getting: " + counter, statusLabel);
        }

        // create client instance 
        //public static myMqtt myMqtt = new myMqtt();
        public MqttClient client; //constructor

        delegate void StringArgReturningVoidDelegate(string text, Label myLbl);
        delegate void BoolArgReturningVoidDelegate(bool state, Button myBtn);

        private void SetText(string text1, Label myLabel)
        {
            // InvokeRequired required compares the thread ID of the  
            // calling thread to the thread ID of the creating thread.  
            // If these threads are different, it returns true.  
            if (myLabel.InvokeRequired) //if (aiName1.InvokeRequired)
            {
                StringArgReturningVoidDelegate d = new StringArgReturningVoidDelegate(SetText);
                this.Invoke(d, new object[] { text1, myLabel });
            }
            else
            {
                try
                {
                    myLabel.Text = text1;
                }
                catch (Exception exc)
                {
                    statusLabel.Text = "SetTextException";
                }
            }
        }


        private void SetButton(bool state, Button myBtn)
        {
            // InvokeRequired required compares the thread ID of the  
            // calling thread to the thread ID of the creating thread.  
            // If these threads are different, it returns true.  
            if (myBtn.InvokeRequired)
            {
                BoolArgReturningVoidDelegate d = new BoolArgReturningVoidDelegate(SetButton);
                this.Invoke(d, new object[] { state, myBtn });
            }
            else
            {
                try
                {
                    myBtn.Enabled = state;
                }
                catch (Exception exc)
                {
                    statusLabel.Text = "SetButtonException";
                }
            }
        }

        private void refreshButton_Click(object sender, EventArgs e)
        {
            SetButton(false, startButton);
            SetButton(true, stopButton);
            listenToTopic();
        }


        void client_MqttMsgPublishReceived(object sender, MqttMsgPublishEventArgs e)
        {
            result = System.Text.Encoding.Default.GetString(e.Message);
            if (e.Topic == writeTopic)
            {
                for (int i = 0; i < 16; i++)
                    SetText(getValueOfXML(result, "DigitalInput" + (i + 1), "Name"), diNameLabels[i]);
                for (int i = 0; i < 16; i++)
                    SetText(getValueOfXML(result, "DigitalInput" + (i + 1), "Value"), diValueLabels[i]);
                for (int i = 0; i < 8; i++)
                    SetText(getValueOfXML(result, "AnalogInput" + (i + 1), "Name"), aiNameLabels[i]);
                for (int i = 0; i < 8; i++)
                    SetText(getValueOfXML(result, "AnalogInput" + (i + 1), "Value"), aiValueLabels[i]);
                for (int i = 0; i < 8; i++)
                    SetText(getValueOfXML(result, "TemperatureInput" + (i + 1), "Name"), tiNameLabels[i]);
                for (int i = 0; i < 8; i++)
                    SetText(getValueOfXML(result, "TemperatureInput" + (i + 1), "Value"), tiValueLabels[i]);
            }
            else if (e.Topic == notificationTopic)
            {
                int startIndex = 0;
                int endIndex = result.IndexOf(">", startIndex);
                SetText(result.Substring(startIndex, endIndex - startIndex), notificationLabel);
                startIndex = endIndex+1;
                endIndex = result.IndexOf(">", startIndex);
                SetText(result.Substring(startIndex, endIndex - startIndex), deviceLabel);
                startIndex = endIndex + 1;
                endIndex = result.Length;
                SetText(result.Substring(startIndex, endIndex - startIndex), datetimeLabel);
            }
        }

        public void endClient()
        {
            aTimer.Enabled = false;
            if (client.IsConnected)
                client.Disconnect();
            client = null;
            if(result != "")
            SetText("", statusLabel);

            for (int i = 0; i < 16; i++)
                SetText("-", diNameLabels[i]);
            for (int i = 0; i < 16; i++)
                SetText("-", diValueLabels[i]);
            for (int i = 0; i < 8; i++)
                SetText("-", aiNameLabels[i]);
            for (int i = 0; i < 8; i++)
                SetText("-", aiValueLabels[i]);
            for (int i = 0; i < 8; i++)
                SetText("-", tiNameLabels[i]);
            for (int i = 0; i < 8; i++)
                SetText("-", tiValueLabels[i]);

            counter = 0;
        }

        public void listenToTopic()
        {
            result = "";
            try
            {
                client = new MqttClient(brokerTextbox.Text);

                // register to message received 
                client.MqttMsgPublishReceived += client_MqttMsgPublishReceived;

                string clientId = Guid.NewGuid().ToString();
                client.Connect(clientId);

                // subscribe to the topic write topic with QoS 0
                writeTopic = GetMd5Hash(macTextbox.Text + "adminwrite" + passwordTextbox.Text);
                client.Subscribe(new string[] { writeTopic }, new byte[] { MqttMsgBase.QOS_LEVEL_AT_MOST_ONCE });
                notificationTopic = GetMd5Hash(macTextbox.Text + "adminnotifications" + passwordTextbox.Text);
                client.Subscribe(new string[] { notificationTopic }, new byte[] { MqttMsgBase.QOS_LEVEL_AT_MOST_ONCE });

                readTopic = GetMd5Hash(macTextbox.Text + "adminread" + passwordTextbox.Text);
                client.Publish(readTopic, Encoding.UTF8.GetBytes("MQTT_COMMAND?GETSTATUS;"));

                aTimer.Interval = Int32.Parse(intervalTextbox.Text);
                aTimer.Enabled = true;
            }
            catch (Exception ex)
            {
                SetText("Error Occured. Check MQTT Settings and/or Internet Connection.", statusLabel);
                SetButton(true, startButton);
                SetButton(false, stopButton);
            }
        }

        public string GetMd5Hash(string input)
        {
            MD5 md5Hash = MD5.Create();

            // Convert the input string to a byte array and compute the hash.
            byte[] data = md5Hash.ComputeHash(Encoding.UTF8.GetBytes(input));

            // Create a new Stringbuilder to collect the bytes
            // and create a string.
            StringBuilder sBuilder = new StringBuilder();

            // Loop through each byte of the hashed data 
            // and format each one as a hexadecimal string.
            for (int i = 0; i < data.Length; i++)
            {
                sBuilder.Append(data[i].ToString("x2"));
            }

            // Return the hexadecimal string.
            return sBuilder.ToString();
        }

        void client_MqttMsgUnsubscribed(object sender, MqttMsgUnsubscribedEventArgs e)
        {
            // write your code
        }

        void client_MqttMsgSubscribed(object sender, MqttMsgSubscribedEventArgs e)
        {
            // write your code
            Console.WriteLine("client_MqttMsgSubscribed");
        }

        public String getValueOfXML(String xmlString, String searchedString, String searchedSubstring)
        {
            int startIndex = xmlString.IndexOf("<" + searchedString + ">");
            startIndex = xmlString.IndexOf("<" + searchedSubstring + ">", startIndex) + searchedSubstring.Length + 2;//("<" + searchedSubstring + ">").length
            int endIndex = xmlString.IndexOf("</" + searchedSubstring + ">", startIndex);
            String result = xmlString.Substring(startIndex, endIndex - startIndex);
            return result;
        }

        private void stopButton_Click(object sender, EventArgs e)
        {
            SetButton(true, startButton);
            SetButton(false, stopButton);
            endClient();
        }
    }
}
